#ifndef WAFERREBUILD_H
#define WAFERREBUILD_H

#ifdef _EXPORTING 
#define API_DECLSPEC    __declspec(dllexport)  
#else  
#define API_DECLSPEC    __declspec(dllimport)  
#endif 

#include <vector>
#include <string>
#include <tuple>
#include "math_tool.h"
#include "image.h"
#include "cloud_point.h"
#include "nlohmann/json.hpp"

class ArithPmd;
class API_DECLSPEC WaferRebuild
{
public:
	WaferRebuild();
	~WaferRebuild();

private:

	ArithPmd* arith_pmd;
public:

	/*
   * @brief  ʼ
   *
   * @param[in]  param    㷨(jsonʽ, 궨)
   * @return     
   */
	std::tuple<int, std::string> initParam(const nlohmann::json& param);

	/*
   * @brief  һ̨ƣɲ
   *
   * @param[in]  image_list  һ̨ͼ
   * @param[out] cloud_points  
   * @param[in] camera_index  id(0 , 1 , 2 , 3)
   * @return     
   */
	std::tuple<int, std::string> calcCloud(const std::vector<std::shared_ptr<infra::Image>>& image_list, std::shared_ptr<infra::CloudPoint<double>>& cloud_points, int32_t camera_index);

	/*
	* @brief  ϲ
	*
	* @param[in]  cloud_points_list  id(0 , 1 , 2 , 3)  Ӧ
	* @param[out] cloud_points  ̨ϲĵ
	* @return     
	*/
	std::tuple<int, std::string> mergeCloud(const std::map<int32_t, std::shared_ptr<infra::CloudPoint<double>>>& cloud_points_list,
		std::shared_ptr<infra::CloudPoint<double>>& cloud_points);

	/*
	* @brief  
	*
	* @param[in]  cloud_points  ϲĵ
	* @param[in]  filterMM  ˳ߴ
	* @param[out]  result  (jsonʽ)result
	* @return     
	*/
	std::tuple<int, std::string> warpage(const std::shared_ptr<infra::CloudPoint<double>>& cloud_points, int32_t filterMM, nlohmann::json& result);

};

#endif // WAFERREBUILD_H